this.name				= "CollapsShields";
this.author				= "Stranger";
this.copyright			= "Creative Commons: attribution, non-commercial, sharealike with clauses - see readme.txt";
this.description		= "Script simulates collapsing shields and fuel consumption";
this.version			= "1.2";

this.shipWillLaunchFromStation = this.startFuelTimer = function()
	{
	this.fuelFlag = 0;
    this.fuelCounter = 0;
    this.energyCounter = player.ship.maxEnergy;
	if(this.fuelWatchTimer)
		{ this.fuelWatchTimer.start(); }
	else
		{ this.fuelWatchTimer = new Timer(this, this.checkFuel,0,1); }
	}

this.shipWillDockWithStation = this.shipDied = this.stopFuelTimer = function()
	{
	this.fuelFlag = 0;
    this.fuelCounter = 0;
    this.energyCounter = player.ship.maxEnergy;    
	if(this.fuelWatchTimer && this.fuelWatchTimer.isRunning) { this.fuelWatchTimer.stop(); } 
	}
	
this.checkFuel = function()
	{	

	if(player.ship.speed > 0)       // basic fuel consumption
		{                           //  increment flag, looping between 0 and 60
		this.fuelFlag += 1;
		this.fuelFlag = this.fuelFlag % 60;
        if (player.ship.speed < 0.8 * player.ship.maxSpeed)
            {
            this.fuelCounter += 1;      // cruise mode
            }
        else
            {
            this.fuelCounter += 2;      // high speed mode
            }
		}
        
	if(player.alertCondition != 1)
		{ 
		this.fuelCounter += 1;      // additional fuel consumption in mass lock state
		}
        
	if(player.ship.energy < player.ship.maxEnergy)
		{ 
		this.fuelCounter += 4;      // additional fuel consumption to recharge energy stock
		}        

	if(this.fuelCounter >= 360)
		{ 
		player.ship.fuel -= 0.1;    // fuel decrement
        this.fuelCounter -= 360;    //reset fuel counter
		}

	if(player.ship.fuel == 0.1)     // warning message - fuel low
		{
		player.consoleMessage("Мало топлива!", 3);
		}

	if(player.ship.fuel == 0)       // fuel empty - shields switch to auxiliary battery
		{
		player.ship.aftShield = 0;
		player.ship.forwardShield = 0;
		player.ship.energy += 2;
        this.energyCounter -= 0.1;  // auxiliary battery discharge rate
		if(player.ship.energy > this.energyCounter)
			{
			player.ship.energy = this.energyCounter;
			}
		if(player.ship.energy <= 0)
            {
            player.ship.explode();
            }
		}
	
	if(player.ship.torusEngaged == true) // if the ship is under jump drive
		{
		if(player.ship.aftShield > 0.25*player.ship.maxAftShield)
            {
            player.ship.aftShield = 0.25*player.ship.maxAftShield;         // shields level decreased
            }
		if(player.ship.forwardShield > 0.25*player.ship.maxForwardShield)
            {
            player.ship.forwardShield = 0.25*player.ship.maxForwardShield;     // ---
            }
		player.ship.energy += 2;
        this.fuelCounter += 4;      // additional fuel consumption in jump drive mode
        if(player.ship.fuel == 0)
            {
            player.ship.energy -= 10;
            }
		if(player.ship.energy <= 0)
            {
            player.ship.explode();
            }
        }
	else
		{ return; }                 // if not under jump drive, exit function
		
	}